////////////////////////////////////////////////////////////////////////
// schedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.schedule")

// <%pre>
#line 1 "schedule.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <timers.h>
#include <recman.h>


#include <vdr/config.h>


using namespace vdrlive;




#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("schedule");

static const char* rawData = "\224\000\000\000\225\000\000\000\226\000\000\000\010\001\000\000\025\001\000\000\032\001"
  "\000\000\037\001\000\000\276\001\000\000\373\001\000\000T\002\000\000\211\002\000\000J\003\000\000O\003\000\000i\003"
  "\000\000o\003\000\000q\003\000\000w\003\000\000y\003\000\000\244\003\000\000\246\003\000\000\263\003\000\000\355\003"
  "\000\000\356\003\000\000\357\003\000\000L\004\000\000f\004\000\000{\004\000\000|\004\000\000\203\004\000\000\204\004"
  "\000\000\211\004\000\000\217\004\000\000\276\004\000\000\301\004\000\000\335\004\000\000\340\004\000\000\341\004\000"
  "\000\n\n\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <titl"
  "e>VDR Live - </title>\n    \n    \n    \n    <script type=\"text/javascript\"><!--\n    function KeyboardInput(ev) {"
  "\n      if (ev.ctrlKey)\n        switch (ev.which) {\n        case 37: // left\n          \n          return false;\n"
  "        case 39: // right\n          \n          return false;\n        }\n        switch (ev.key) {\n        case '<"
  "':\n          \n          return false;\n        case '>':\n          \n          return false;\n        }\n      ret"
  "urn true;\n    }\n    //--></script>\n  </head>\n  <body onload=\"adjustHeader()\" onresize=\"adjustHeader()\" onkeyd"
  "own=\"return KeyboardInput(event);\">\n    \n    \n    <div class=\"inhalt\">\n      .\n      .\n<script>\ndocument.w"
  "rite(addEventListString(, ))\n</script>\n    </div>\n  <script>imgLoad()</script>\n  </body>\n</html>\n\n\n<form acti"
  "on=\"schedule.html\" method=\"get\" id=\"channels\">\n   <span>\n     <label for=\"channel\">:&nbsp;<span class=\"bol"
  "d\"></span></label>\n     \n       \n     \n     \n   </span>\n</form>\n<span class=\"sep\">|</span>\n\302\253 \n<spa"
  "n class=\"sep\">|</span>\n \302\273\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
std::string channelid = qparam.get< std::string >("channelid");
  // </%args>

#line 24 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 29 "schedule.ecpp"
  typedef tChannelID channel_id_type;
  TNT_REQUEST_SHARED_VAR(tChannelID, channel_id, ( tChannelID()));   // <%request> tChannelID channel_id( tChannelID())
  _tnt_ignore_unused<channel_id_type>(channel_id);
#line 30 "schedule.ecpp"
  typedef int channel_number_type;
  TNT_REQUEST_SHARED_VAR(int, channel_number, ( 0));   // <%request> int channel_number( 0)
  _tnt_ignore_unused<channel_number_type>(channel_number);
#line 31 "schedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 32 "schedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 35 "schedule.ecpp"

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

#line 43 "schedule.ecpp"

  pageTitle = trVDR("Schedule");

bool display_pictures = !(LiveSetup().GetTvscraperImageDir().empty());
bool events_available = false;

{
// figure out channel_id & channel_number
  const cChannel* Channel = nullptr;
  LOCK_CHANNELS_READ;
  if ( qparam.has("channelid") ) {
    tChannelID cid = cid.FromString(channelid.c_str());
    Channel = Channels->GetByChannelID( cid );
  } else if ( channel > 0 )
    Channel = Channels->GetByNumber( channel );
  else if (cDevice::CurrentChannel())
    Channel = Channels->GetByNumber(cDevice::CurrentChannel());
  else
    Channel = Channels->Get( Channels->GetNextNormal( -1 ) );
  if ( !Channel )
    throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
  channel_id = Channel->GetChannelID();
  channel_number = Channel->Number();
  if (channel_number > 1)
    prev = cString::sprintf("href=\"schedule.html?channel=%i\"", channel_number - 1);
  if (channel_number < Channels->MaxNumber())
    next = cString::sprintf("href=\"schedule.html?channel=%i\"", channel_number + 1);

  LOCK_SCHEDULES_READ;
  cSchedule const* Schedule = Schedules->GetSchedule(Channel);
  events_available = Schedule && Schedule->Events()->First();
}



  // <& pageelems.doc_type ...
  { 
#line 78 "schedule.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 78 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR Live - 
#line 82 "schedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[3]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 83 "schedule.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 83 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 84 "schedule.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 84 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 85 "schedule.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 85 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    <script type="text/javascript"><!--\n    function KeyboardInput(ev) {\n      if (ev.ctrlKey)\n        switch (ev.which) {\n        case 37: // left\n          
#line 91 "schedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[7]; // \n          return false;\n        case 39: // right\n          
#line 94 "schedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[8]; // \n          return false;\n        }\n        switch (ev.key) {\n        case '<':\n          
#line 99 "schedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[9]; // \n          return false;\n        case '>':\n          
#line 102 "schedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[10]; // \n          return false;\n        }\n      return true;\n    }\n    //--></script>\n  </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()" onkeydown="return KeyboardInput(event);">\n    
  // <& pageelems.logo ...
  { 
#line 110 "schedule.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 110 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n    
  // <& menu ...
  { 
#line 111 "schedule.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 111 "schedule.ecpp"
    _tnt_cq5.add( "active", ("schedule"));
#line 111 "schedule.ecpp"
    _tnt_cq5.add( "component", ("schedule.channel_selection"));
#line 111 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[12]; // \n    <div class="inhalt">\n
#line 113 "schedule.ecpp"

  if (!events_available) {

  reply.out() << _tntChunks[13]; //       
#line 116 "schedule.ecpp"
  reply.sout() << ( tr("No schedules available for this channel") );
  reply.out() << _tntChunks[14]; // .\n
#line 117 "schedule.ecpp"

  }
  else {
    int col_span = 3;
    if (display_pictures) col_span++;
    std::string current_day = "";
    time_t now = time(NULL) - ::Setup.EPGLinger * 60;
    cToSvConcat<0> epg_item;
    epg_item.reserve(10000);
    epg_item.concat('[');
    {
      LOCK_TIMERS_READ;
      LOCK_CHANNELS_READ;
      LOCK_RECORDINGS_READ;  // required because appendEpgItemWithRecItem needs also lock on recording
      LOCK_SCHEDULES_READ;
      const cChannel* Channel = Channels->GetByChannelID(channel_id);
      cSchedule const* Schedule = Schedules->GetSchedule(Channel);
      const cEvent* PresentEvent = Schedule->GetPresentEvent();
      for (const cEvent *Event = Schedule->Events()->First(); Event; Event = Schedule->Events()->Next(Event)) {
        if (Event->EndTime() <= now && Event != PresentEvent) continue;
        current_day = appendEpgItemWithRecItem(epg_item, current_day, Event, Channel, false, Timers);
      }
    }
    epg_item.concat("]]]");
    if (current_day.empty() ) {

  reply.out() << _tntChunks[15]; //       
#line 143 "schedule.ecpp"
  reply.sout() << ( tr("No events available for this channel") );
  reply.out() << _tntChunks[16]; // .\n
#line 144 "schedule.ecpp"
   } else {

  reply.out() << _tntChunks[17]; // <script>\ndocument.write(addEventListString(
#line 146 "schedule.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[18]; // , 
#line 146 "schedule.ecpp"
  reply.out() << ( epg_item.c_str() );
  reply.out() << _tntChunks[19]; // ))\n</script>\n
#line 148 "schedule.ecpp"

    }
  }

  reply.out() << _tntChunks[20]; //     </div>\n  <script>imgLoad()</script>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[21]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[22]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 24 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 29 "schedule.ecpp"
  typedef tChannelID channel_id_type;
  TNT_REQUEST_SHARED_VAR(tChannelID, channel_id, ( tChannelID()));   // <%request> tChannelID channel_id( tChannelID())
  _tnt_ignore_unused<channel_id_type>(channel_id);
#line 30 "schedule.ecpp"
  typedef int channel_number_type;
  TNT_REQUEST_SHARED_VAR(int, channel_number, ( 0));   // <%request> int channel_number( 0)
  _tnt_ignore_unused<channel_number_type>(channel_number);
#line 31 "schedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 32 "schedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[23]; // <form action="schedule.html" method="get" id="channels">\n   <span>\n     <label for="channel">
#line 161 "schedule.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[24]; // :&nbsp;<span class="bold">
#line 161 "schedule.ecpp"
  reply.sout() << ( cToSvInt(channel_number) );
  reply.out() << _tntChunks[25]; // </span></label>\n     
  // <& channels_widget ...
  { 
#line 162 "schedule.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 162 "schedule.ecpp"
    _tnt_cq6.add( "name", ("channel"));
#line 162 "schedule.ecpp"
    _tnt_cq6.add( "onchange", ("document.forms.channels.submit()"));
#line 162 "schedule.ecpp"
    _tnt_cq6.add( "selected", (channel_id));
#line 162 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[26]; // \n
#line 163 "schedule.ecpp"
    if (cDevice::PrimaryDevice() ) {

  reply.out() << _tntChunks[27]; //        
  // <& pageelems.ajax_action_href ...
  { 
#line 164 "schedule.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 164 "schedule.ecpp"
    _tnt_cq7.add( "action", "switch_channel");
#line 164 "schedule.ecpp"
    _tnt_cq7.add( "alt", "");
#line 164 "schedule.ecpp"
    _tnt_cq7.add( "image", "zap.png");
#line 164 "schedule.ecpp"
    _tnt_cq7.add( "param", (channel_id));
#line 164 "schedule.ecpp"
    _tnt_cq7.add( "tip", (tr("Switch to this channel.")));
#line 164 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[28]; // \n
#line 165 "schedule.ecpp"
    }

  reply.out() << _tntChunks[29]; //      
  // <& pageelems.hls_channel ...
  { 
#line 166 "schedule.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 166 "schedule.ecpp"
    _tnt_cq8.add( "channelId", (channel_id));
#line 166 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n     
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 167 "schedule.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 167 "schedule.ecpp"
    _tnt_cq9.add( "channelId", (channel_id));
#line 167 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[31]; // \n   </span>\n</form>\n<span class="sep">|</span>\n
#line 171 "schedule.ecpp"
  if ( *prev )
    reply.out() <<  "<a " << *prev << ">";
  reply.out() << _tntChunks[32]; // \302\253 
#line 171 "schedule.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 171 "schedule.ecpp"
  if ( *prev )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[33]; // \n<span class="sep">|</span>\n
#line 173 "schedule.ecpp"
  if ( *next )
    reply.out() <<  "<a " << *next << ">";
#line 173 "schedule.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[34]; //  \302\273
#line 173 "schedule.ecpp"
  if ( *next )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[35]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
